/**
   The prettyPrint() method takes a BTree and
   converts it into a well formatted string.
*/

public class PrettyPrinter
{
   public static String prettyPrint(BTree tree)
   {
      return prettyPrint(tree, "");
   }

   /**
      This prettyPrint() method is essentially a
      pre-order traversal of the tree.
   */
   private static String prettyPrint(BTree tree, String indentation)
   {
      String result = "";

      if ( 0 == tree.degree() )  // this stops the recursion
      {
         result += indentation + tree.getElement();
      }
      else
      {
         // "process" the current node
         result += indentation + "(" + tree.getElement() + "\n";

         // recursively traverse the left sub tree
         if ( null != tree.getLeftTree() )
            result += prettyPrint( tree.getLeftTree(), indentation+"  " ) + "\n";
         else
            result += indentation + "  ()\n";

         // recursively traverse the right sub tree
         if ( null != tree.getRightTree() )
            result += prettyPrint( tree.getRightTree(), indentation+"  " ) + "\n";
         else
            result += indentation + "  ()\n";

         result += indentation + ")";
      }
      return result;
   }//prettyPrint()

}//PrettyPrinter