/*
   For each arithmetic expression given in a comment
   in the array bTrees, use another comment to write
   the tree language syntax for the expression's
   abstract syntax tree, and then write the Java code
   that instantiates the expression's abstract syntax
   tree.

   The first two expressions are already done for you.


   This program assumes that you have installed the
   Graphviz package, which includes the dot.exe program.
   You can download the installer for Graphviz and dot.exe
   from this URL.

     http://www.graphviz.org/pub/graphviz/stable/windows/graphviz-2.28.0.msi
*/

public class Tests_Part_1
{
   public static void main(String[] args)
   {
      BTree[] bTrees = {
         // 3 + 4 + 5 * 6
         // (+ (+ 3 4) (* 5 6))
         new BTree("+", new BTree("+", new BTree("3"), new BTree("4")),
                        new BTree("*", new BTree("5"), new BTree("6"))),

         // 3 + (4 + 5) * 6
         // (+ 3 (* (+ 4 5) 6))
         new BTree("+", new BTree("3"),
                        new BTree("*", new BTree("+", new BTree("4"), new BTree("5")),
                                       new BTree("6"))),

         // (3 + 4 + 5) * 6


         // 3 + 4 * 5 + 6


         // (3 + 4) * (5 + 6)


         // 3 * 4 + 5 * 6


         // 3 * (4 + 5) * 6


      };

      for ( int i = 0; i < bTrees.length; i++)
      {
         // Prettyprint the BTree
         System.out.println( PrettyPrinter.prettyPrint( bTrees[i] ) + "\n" );

         // Evaluate the BTree.
         System.out.println(" ==> " + Evaluate.eval(bTrees[i]) );

         System.out.println("=======================");

         // Create dot and png files from the BTree.
         try
         {
            // Create the (empty) dot file.
            java.io.PrintWriter out = new java.io.PrintWriter(
                                         new java.io.File("Tests_Part_1." + i + ".dot"));
            // Put dot commands into the dot file
            out.println( BTree2dot.btree2dot(bTrees[i]) + "\n" );
            out.close();

            // Create a Windows command line for running dot.exe.
            String[] cmd = {"dot.exe",
                            "-Tpng",
                            "Tests_Part_1." + i + ".dot",
                            "-o",
                            "Tests_Part_1." + i + ".png"};
            // Execute the command line.
            java.lang.Runtime.getRuntime().exec(cmd);
         }
         catch (Exception e)
         {
            System.out.println( e );
         }
    }
   }//main

}//Tests
